/**
 * Array 工具类
 */

const ArrayUtils = {};

ArrayUtils.add = function (array, item) {
  return array.push(item);
}

ArrayUtils.addRange = function (array, items) {
  var length = items.length;

  if (length != 0) {
    for (var index = 0; index < length; index++) {
      array.push(items[index]);
    }
  }
  return array;
}

ArrayUtils.clear = function (array) {
  if (array.length > 0) {
    array.splice(0, array.length);
  }
  return array;
}

ArrayUtils.isEmpty = function (array) {
  if (array.length == 0)
    return true;
  else
    return false;
}

ArrayUtils.clone = function (array) {
  var clonedArray = [];
  var length = array.length;

  for (var index = 0; index < length; index++) {
    clonedArray[index] = array[index];
  }

  return clonedArray;
}

ArrayUtils.contains = function (array, item) {
  var index = array.indexOf(item);
  return (index >= 0);
}

ArrayUtils.dequeue = function (array) {
  return array.shift();
}

ArrayUtils.indexOf = function (array, item) {
  var length = array.length;

  if (length != 0) {
    for (var index = 0; index < length; index++) {
      if (array[index] == item) {
        return index;
      }
    }
  }

  return -1;
}

ArrayUtils.insert = function (array, index, item) {
  return array.splice(index, 0, item);
}

ArrayUtils.joinstr = function (array, str) {
  var new_arr = new Array(array.length);
  for (var i = 0; i < array.length; i++) {
    new_arr[i] = array[i] + str;
  }
  return new_arr;
}

ArrayUtils.queue = function (array, item) {
  return array.push(item);
}

ArrayUtils.remove = function (array, item) {
  var array = array.indexOf(item);

  if (index >= 0) {
    array.splice(index, 1);
  }
  return array;
}

ArrayUtils.removeAt = function (array, index) {
  return array.splice(index, 1);
}

export default ArrayUtils;
